%define	name	liboop
%define	version	0.5
%define	release	2
%define	serial	1

Summary:	A low-level event loop management library.
Name:		%{name}
Version:	%{version}
Release:	%{release}
Serial:		%{serial}
Copyright:	LGPL
Group:		Development/Libraries
URL:		http://ofb.net/~egnor/oop/
Vendor:		Dan Egnor <egnor@gale.org>
Provides:	liboop
Source0:	http://gale.org/dist/liboop-%{version}.tar.gz
BuildRoot:	/var/tmp/%{name}-%{version}

Distribution:	Gale Distribution
Packager:	Erik Ogan <erik@slackers.net>
Requires:	adns >= 0.5

%package devel
Group:		Development/Libraries
Summary:        Liboop Development Headers
Requires:       liboop

%description 
Liboop is a low-level event loop management library for POSIX-based operating 
systems. It supports the development of modular, multiplexed applications 
which may respond to events from several sources. It replaces the ``select() 
loop'' and allows the registration of event handlers for file and network I/O, 
timers and signals. Since processes use these mechanisms for almost all 
external communication, liboop can be used as the basis for almost any 
application.

%description devel
Liboop is a low-level event loop management library for POSIX-based operating 
systems.  This is the development package needed to build programs with liboop.

%prep
%setup
%configure --prefix=/usr 

%build
if [ -x /usr/bin/getconf ] ; then
    NRPROC=$(/usr/bin/getconf _NPROCESSORS_ONLN)
    if [ $NRPROC -eq 0 ] ; then
	NRPROC=1
    fi
else
    NRPROC=1
fi



CFLAGS=""
MAKE="make"
%ifarch i586 i686
CFLAGS="-g -O2 -mcpu=%{_target_cpu}"
MAKE='make -j$NRPROC'
%endif
cd $RPM_BUILD_DIR/%{name}-%{version}
make MAKE="$MAKE" CFLAGS="$CFLAGS"

%install

if [ -d $RPM_BUILD_ROOT ] && [ ! -L $RPM_BUILD_ROOT ]; then rm -rf $RPM_BUILD_ROOT; fi
mkdir -p $RPM_BUILD_ROOT/usr/lib
mkdir -p $RPM_BUILD_ROOT/usr/bin
mkdir -p $RPM_BUILD_ROOT/usr/include
cd $RPM_BUILD_DIR/%{name}-%{version}
make prefix=$RPM_BUILD_ROOT/usr install 

%clean
if [ -d $RPM_BUILD_ROOT ] && [ ! -L $RPM_BUILD_ROOT ]; then rm -rf $RPM_BUILD_ROOT; fi

%files
%defattr(-,root,root)
/usr/lib

%files devel
/usr/include
